from fontTools.ttLib.tables._n_a_m_e import _WINDOWS_LANGUAGES, _MAC_LANGUAGES

NAME_IDS = {
    0: "Copyright Notice",
    1: "Family name",
    2: "Subfamily name",
    3: "Unique identifier",
    4: "Full font name",
    5: "Version string",
    6: "PostScript name",
    7: "Trademark",
    8: "Manufacturer Name",
    9: "Designer",
    10: "Description",
    11: "URL Vendor",
    12: "URL Designer",
    13: "License Description",
    14: "License Info URL",
    15: "Reserved",
    16: "Typographic Family",
    17: "Typographic Subfamily",
    18: "Compatible Full (Mac)",
    19: "Sample text",
    20: "PS CID font name",
    21: "WWS Family Name",
    22: "WWS Subfamily Name",
    23: "Light Background Palette",
    24: "Dark Background Palette",
    25: "Variations PSName Pref",
}

PLATFORMS = {
    0: "Unicode",
    1: "Macintosh",
    2: "ISO (deprecated)",
    3: "Windows",
    4: "Custom",
}

MAC_ENCODING_IDS = {
    0: "Roman",
    1: "Japanese",
    2: "Chinese (Traditional)",
    3: "Korean",
    4: "Arabic",
    5: "Hebrew",
    6: "Greek",
    7: "Russian",
    8: "RSymbol",
    9: "Devanagari",
    10: "Gurmukhi",
    11: "Gujarati",
    12: "Oriya",
    13: "Bengali",
    14: "Tamil",
    15: "Telugu",
    16: "Kannada",
    17: "Malayalam",
    18: "Sinhalese",
    19: "Burmese",
    20: "Khmer",
    21: "Thai",
    22: "Laotian",
    23: "Georgian",
    24: "Armenian",
    25: "Chinese (Simplified)",
    26: "Tibetan",
    27: "Mongolian",
    28: "Geez",
    29: "Slavic",
    30: "Vietnamese",
    31: "Sindhi",
    32: "Uninterpreted",
}

WINDOWS_ENCODING_IDS = {
    0: "Symbol",
    1: "Unicode",
    2: "ShiftJIS",
    3: "PRC",
    4: "Big5",
    5: "Wansung",
    6: "Johab",
    7: "Reserved",
    8: "Reserved",
    9: "Reserved",
    10: "UCS4",
}

EMBED_LEVEL_STRINGS = {
    0: "Installable embedding",
    2: "Restricted License embedding",
    4: "Preview & Print embedding",
    8: "Editable embedding",
}

MAX_FAMILY_NAME_LEN = 27
MAX_FULL_NAME_LEN = 31
MAX_POSTSCRIPT_NAME_LEN = 29

LANGUAGES_EPILOG = f"""
MACINTOSH LANGUAGES: {", ".join([lang for lang in _MAC_LANGUAGES.values()])}

WINDOWS LANGUAGES: f{", ".join([lang for lang in _WINDOWS_LANGUAGES.values()])}
"""

PANOSE_ANY = PANOSE_NO_FIT = {
    "bSerifStyle": {
        "description": "Serif style",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bWeight": {
        "description": "Weight",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bProportion": {
        "description": "Proportion",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bContrast": {
        "description": "Contrast",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bStrokeVariation": {
        "description": "Stroke Variation",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bArmStyle": {
        "description": "Arm Style",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bLetterForm": {
        "description": "Letterform",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bMidline": {
        "description": "Midline",
        "values": {0: "Any", 1: "No Fit"},
    },
    "bXHeight": {
        "description": "X-height",
        "values": {0: "Any", 1: "No Fit"},
    },
}

PANOSE_LATIN_TEXT = {
    "bSerifStyle": {
        "description": "Serif style",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Cove",
            3: "Obtuse Cove",
            4: "Square Cove",
            5: "Obtuse Square Cove",
            6: "Square",
            7: "Thin",
            8: "Oval",
            9: "Exaggerated",
            10: "Triangle",
            11: "Normal Sans",
            12: "Obtuse Sans",
            13: "Perpendicular Sans",
            14: "Flared",
            15: "Rounded",
        },
    },
    "bWeight": {
        "description": "Weight",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Very Light",
            3: "Light",
            4: "Thin",
            5: "Book",
            6: "Medium",
            7: "Demi",
            8: "Bold",
            9: "Heavy",
            10: "Black",
            11: "Extra Black",
        },
    },
    "bProportion": {
        "description": "Proportion",
        "values": {
            0: "Any",
            1: "No fit",
            2: "Old Style",
            3: "Modern",
            4: "Even Width",
            5: "Extended",
            6: "Condensed",
            7: "Very Extended",
            8: "Very Condensed",
            9: "Monospaced",
        },
    },
    "bContrast": {
        "description": "Contrast",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "None",
            3: "Very Low",
            4: "Low",
            5: "Medium Low",
            6: "Medium",
            7: "Medium High",
            8: "High",
            9: "Very High",
        },
    },
    "bStrokeVariation": {
        "description": "Stroke Variation",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Variation",
            3: "Gradual/Diagonal",
            4: "Gradual/Transitional",
            5: "Gradual/Vertical",
            6: "Gradual/Horizontal",
            7: "Rapid/Vertical",
            8: "Rapid/Horizontal",
            9: "Instant/Vertical",
            10: "Instant/Horizontal",
        },
    },
    "bArmStyle": {
        "description": "Arm Style",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Straight Arms/Horizontal",
            3: "Straight Arms/Wedge",
            4: "Straight Arms/Vertical",
            5: "Straight Arms/Single Serif",
            6: "Straight Arms/Double Serif",
            7: "Non-Straight/Horizontal",
            8: "Non-Straight/Wedge",
            9: "Non-Straight/Vertical",
            10: "Non-Straight/Single Serif",
            11: "Non-Straight/Double Serif",
        },
    },
    "bLetterForm": {
        "description": "Letterform",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Normal/Contact",
            3: "Normal/Weighted",
            4: "Normal/Boxed",
            5: "Normal/Flattened",
            6: "Normal/Rounded",
            7: "Normal/Off Center",
            8: "Normal/Square",
            9: "Oblique/Contact",
            10: "Oblique/Weightedv",
            11: "Oblique/Boxed",
            12: "Oblique/Flattened",
            13: "Oblique/Rounded",
            14: "Oblique/Off Center",
            15: "Oblique/Square",
        },
    },
    "bMidline": {
        "description": "Midline",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Standard/Trimmed",
            3: "Standard/Pointed",
            4: "Standard/Serifed",
            5: "High/Trimmed",
            6: "High/Pointed",
            7: "High/Serifed",
            8: "Constant/Trimmed",
            9: "Constant/Pointed",
            10: "Constant/Serifed",
            11: "Low/Trimmed",
            12: "Low/Pointed",
            13: "Low/Serifed",
        },
    },
    "bXHeight": {
        "description": "X-Height",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Constant/Small",
            3: "Constant/Standard",
            4: "Constant/Large",
            5: "Ducking/Small",
            6: "Ducking/Standard",
            7: "Ducking/Large",
        },
    },
}

PANOSE_LATIN_HANDWRITTEN = {
    "bSerifStyle": {
        "description": "Tool kind",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Flat Nib",
            3: "Pressure Point",
            4: "Engraved",
            5: "Ball (Round Cap)",
            6: "Brush",
            7: "Rough",
            8: "Felt Pen/Brush Tip",
            9: "Wild Brush - Drips a lot",
        },
    },
    "bWeight": {
        "description": "Weight",
        "values": PANOSE_LATIN_TEXT["bWeight"]["values"],
    },
    "bProportion": {
        "description": "Spacing",
        "values": {
            0: "Any",
            1: "No fit",
            2: "Proportional Spaced",
            3: "Monospaced",
        },
    },
    "bContrast": {
        "description": "Aspect Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Very Condensed",
            3: "Condensed",
            4: "Normal",
            5: "Expanded",
            6: "Very Expanded",
        },
    },
    "bStrokeVariation": {
        "description": "Contrast",
        "values": PANOSE_LATIN_TEXT["bContrast"]["values"],
    },
    "bArmStyle": {
        "description": "Topology",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Roman Disconnected",
            3: "Roman Trailing",
            4: "Roman Connected",
            5: "Cursive Disconnected",
            6: "Cursive Trailing",
            7: "Cursive Connected",
            8: "Blackletter Disconnected",
            9: "Blackletter Trailing",
            10: "Blackletter Connected",
        },
    },
    "bLetterForm": {
        "description": "Form",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Upright / No Wrapping",
            3: "Upright / Some Wrapping",
            4: "Upright / More Wrapping",
            5: "Upright / Extreme Wrapping",
            6: "Oblique / No Wrapping",
            7: "Oblique / Some Wrapping",
            8: "Oblique / More Wrapping",
            9: "Oblique / Extreme Wrapping",
            10: "Exaggerated / No Wrapping",
            11: "Exaggerated / Some Wrapping",
            12: "Exaggerated / More Wrapping",
            13: "Exaggerated / Extreme Wrapping",
        },
    },
    "bMidline": {
        "description": "Finials",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "None / No loops",
            3: "None / Closed loops",
            4: "None / Open loops",
            5: "Sharp / No loops",
            6: "Sharp / Closed loops",
            7: "Sharp / Open loops",
            8: "Tapered / No loops",
            9: "Tapered / Closed loops",
            10: "Tapered / Open loops",
            11: "Round / No loops",
            12: "Round / Closed loops",
            13: "Round / Open loops",
        },
    },
    "bXHeight": {
        "description": "X-Ascent",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Very Low",
            3: "Low",
            4: "Medium",
            5: "High",
            6: "Very High",
        },
    },
}

PANOSE_LATIN_DECORATIVE = {
    "bSerifStyle": {
        "description": "Class",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Derivative",
            3: "Non-standard Topology",
            4: "Non-standard Elements",
            5: " Non-standard Aspect",
            6: "Initials",
            7: "Cartoon",
            8: "Picture Stems",
            9: "Ornamented",
            10: "Text and Background",
            11: "Collage",
            12: "Montage",
        },
    },
    "bWeight": {
        "description": "Weight",
        "values": PANOSE_LATIN_TEXT["bWeight"]["values"],
    },
    "bProportion": {
        "description": "Aspect",
        "values": {
            0: "Any",
            1: "No fit",
            2: "Super Condensed",
            3: "Very Condensed",
            4: "Condensed",
            5: "Normal",
            6: "Extended",
            7: "Very Extended",
            8: "Super Extended",
            9: "Monospaced",
        },
    },
    "bContrast": {
        "description": "Contrast",
        "values": {
            **PANOSE_LATIN_TEXT["bContrast"]["values"],
            **{10: "Horizontal Low", 11: "Horizontal Medium", 12: "Horizontal High", 13: "Broken"},
        },
    },
    "bStrokeVariation": {
        "description": "Serif Variant",
        "values": {**PANOSE_LATIN_TEXT["bSerifStyle"]["values"], **{16: "Script"}},
    },
    "bArmStyle": {
        "description": "Treatment",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "None - Standard Solid Fill",
            3: "White / No Fill",
            4: "Patterned Fill",
            5: "Complex Fill",
            6: "Shaped Fill",
            7: "Drawn / Distressed",
        },
    },
    "bLetterForm": {
        "description": "Lining",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "None",
            3: "Inline",
            4: "Outline",
            5: "Engraved (Multiple Lines)",
            6: "Shadow",
            7: "Relief",
            8: "Backdrop",
        },
    },
    "bMidline": {
        "description": "Topology",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Standard",
            3: "Square",
            4: "Multiple Segment",
            5: "Deco (E,M,S) Waco midlines",
            6: "Uneven Weighting",
            7: "Diverse Arms",
            8: "Diverse Forms",
            9: "Lombardic Forms",
            10: "Upper Case in Lower Case",
            11: "Implied Topology",
            12: "Horseshoe E and A",
            13: "Cursive",
            14: "Blackletter",
            15: "Swash Variance",
        },
    },
    "bXHeight": {
        "description": "Range of Characters",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Extended Collection",
            3: "Litterals",
            4: "No Lower Case",
            5: "Small Caps",
        },
    },
}

PANOSE_LATIN_PICTORIAL = {
    "bSerifStyle": {
        "description": "Kind",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "Montages",
            3: "Pictures",
            4: "Shapes",
            5: "Scientific",
            6: "Music",
            7: "Expert",
            8: "Patterns",
            9: "Boarders",
            10: "Icons",
            11: "Logos",
            12: "Industry specific",
        },
    },
    "bWeight": {
        "description": "Weight",
        "values": {1: "No Fit"},
    },
    "bProportion": {
        "description": "Spacing",
        "values": {
            0: "Any",
            1: "No fit",
            2: "Proportional Spaced",
            3: "Monospaced",
        },
    },
    "bContrast": {
        "description": "Contrast",
        "values": {
            1: "No Fit",
        },
    },
    "bStrokeVariation": {
        "description": "Character 94 Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Width",
            3: "Exceptionally Wide",
            4: "Super Wide",
            5: "Very Wide",
            6: "Wide",
            7: "Normal",
            8: "Narrow",
            9: "Very Narrow",
        },
    },
    "bArmStyle": {
        "description": "Character 119 Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Width",
            3: "Exceptionally Wide",
            4: "Super Wide",
            5: "Very Wide",
            6: "Wide",
            7: "Normal",
            8: "Narrow",
            9: "Very Narrow",
        },
    },
    "bLetterForm": {
        "description": "Character 157 Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Width",
            3: "Exceptionally Wide",
            4: "Super Wide",
            5: "Very Wide",
            6: "Wide",
            7: "Normal",
            8: "Narrow",
            9: "Very Narrow",
        },
    },
    "bMidline": {
        "description": "Character 163 Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Width",
            3: "Exceptionally Wide",
            4: "Super Wide",
            5: "Very Wide",
            6: "Wide",
            7: "Normal",
            8: "Narrow",
            9: "Very Narrow",
        },
    },
    "bXHeight": {
        "description": "Character 211 Ratio",
        "values": {
            0: "Any",
            1: "No Fit",
            2: "No Width",
            3: "Exceptionally Wide",
            4: "Super Wide",
            5: "Very Wide",
            6: "Wide",
            7: "Normal",
            8: "Narrow",
            9: "Very Narrow",
        },
    },
}

PANOSE_STRUCT = {
    "bFamilyType": {
        0: {"description": "Any", "sub_digits": PANOSE_ANY},
        1: {"description": "No Fit", "sub_digits": PANOSE_NO_FIT},
        2: {"description": "Latin Text", "sub_digits": PANOSE_LATIN_TEXT},
        3: {"description": "Latin Handwritten", "sub_digits": PANOSE_LATIN_HANDWRITTEN},
        4: {"description": "Latin Decorative", "sub_digits": PANOSE_LATIN_DECORATIVE},
        5: {"description": "Latin Pictorial", "sub_digits": PANOSE_LATIN_PICTORIAL},
    },
}
